#![deny(clippy::all)]
#![allow(clippy::blanket_clippy_restriction_lints)]
#![forbid(
    clippy::style,
    clippy::pedantic,
    clippy::nursery,
    clippy::restriction,
    // clippy::cargo
)]

//! my code and notes from the book "Learn Rust in a Month of Lunches"

use tracing::info;
use tracing_subscriber::fmt::init as init_trace_logger;

/// a doc comment - use `cargo doc --open` to see it?
fn main() {
    init_trace_logger();

    {
        // ch 1
        let my_char = '\u{D1EA}';
        info!("Hello, world! {my_char}");
    };

    {
        // ch 2
        let bytes = b"yoyoyo";
        info!("Hello, bytes! {bytes:?}");
    };

    {
        let me = "meeeeeeeeeeeeeeeeeeeeeeeeeee";
        info!("Hello, {me: <4.12}, meet the real {me}.");
    };
}

// if I were to write a webapp, I would like to avoid postgres
// not because postgres is bad, but I want to tinker with embeddable DBs such
// as RocksDB
